Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopeComptonModel.cc,v 1.2 2008/12/04 14:11:21 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeComptonModel.cc,v 1.4 2009/04/18 18:29:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Luciano Pandola
@@ -40,4 +40,8 @@
 //			      that are read from the external files.
 // 24 Nov 2008   L Pandola    Find a cleaner way to delete vectors.
+// 16 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - do not apply production threshold on level of the model
 //
 
@@ -69,5 +73,5 @@
   fIntrinsicLowEnergyLimit = 100.0*eV;
   fIntrinsicHighEnergyLimit = 100.0*GeV;
-  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
+  //  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
   SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
   //
@@ -118,5 +122,5 @@
 
 void G4PenelopeComptonModel::Initialise(const G4ParticleDefinition* particle,
-                                       const G4DataVector& cuts)
+					const G4DataVector& cuts)
 {
   if (verboseLevel > 3)
@@ -124,29 +128,15 @@
 
   InitialiseElementSelectors(particle,cuts);
-  if (LowEnergyLimit() < fIntrinsicLowEnergyLimit)
-    {
-      G4cout << "G4PenelopeComptonModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << fIntrinsicLowEnergyLimit/eV << " eV" << G4endl;
-      SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
-    }
-  if (HighEnergyLimit() > fIntrinsicHighEnergyLimit)
-    {
-      G4cout << "G4PenelopeComptonModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << fIntrinsicHighEnergyLimit/GeV << " GeV" << G4endl;
-      SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
-    }
-
-  G4cout << "Penelope Compton model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+
+  if (verboseLevel > 0) {
+    G4cout << "Penelope Compton model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / keV << " keV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true; 
 }
@@ -249,11 +239,11 @@
   G4double photonEnergy0 = aDynamicGamma->GetKineticEnergy();
 
-  if (photonEnergy0 <= LowEnergyLimit())
-  {
+  if (photonEnergy0 <= fIntrinsicLowEnergyLimit)
+    {
       fParticleChange->ProposeTrackStatus(fStopAndKill);
       fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy0);
       return ;
-  }
+    }
 
   G4ParticleMomentum photonDirection0 = aDynamicGamma->GetMomentumDirection();
@@ -263,5 +253,6 @@
     G4cout << "Going to select element in " << couple->GetMaterial()->GetName() << G4endl;
   // atom can be selected effitiantly if element selectors are initialised 
-  const G4Element* anElement = SelectRandomAtom(couple,G4Gamma::GammaDefinition(),photonEnergy0);
+  const G4Element* anElement = 
+    SelectRandomAtom(couple,G4Gamma::GammaDefinition(),photonEnergy0);
   G4int Z = (G4int) anElement->GetZ();
   if (verboseLevel > 2)
@@ -320,5 +311,5 @@
       }while((epsilon*photonEnergy0-photonEnergy0+ionEnergy) >0);
     }
-  else //photonEnergy0<5 MeV
+  else //photonEnergy0 < 5 MeV
     {
       //Incoherent scattering function for theta=PI
@@ -472,9 +463,9 @@
   }
   
-
   //Create scattered electron
   G4double diffEnergy = photonEnergy0*(1-epsilon);
   ionEnergy = (*(ionizationEnergy->find(Z)->second))[iosc];
-  G4double Q2 = photonEnergy0*photonEnergy0+photonEnergy1*(photonEnergy1-2.0*photonEnergy0*cosTheta);
+  G4double Q2 = 
+    photonEnergy0*photonEnergy0+photonEnergy1*(photonEnergy1-2.0*photonEnergy0*cosTheta);
   G4double cosThetaE; //scattering angle for the electron
   if (Q2 > 1.0e-12)
@@ -496,8 +487,10 @@
   G4int shellId = shell->ShellId();
   G4double ionEnergyInPenelopeDatabase = ionEnergy;
-  ionEnergy = std::max(bindingEnergy,ionEnergyInPenelopeDatabase); //protection against energy non-conservation 
-
-  G4double eKineticEnergy = diffEnergy - ionEnergy; //subtract the excitation energy. If not emitted by fluorescence,
+  //protection against energy non-conservation
+  ionEnergy = std::max(bindingEnergy,ionEnergyInPenelopeDatabase);  
+
+  //subtract the excitation energy. If not emitted by fluorescence
   //the ionization energy is deposited as local energy deposition
+  G4double eKineticEnergy = diffEnergy - ionEnergy; 
   G4double localEnergyDeposit = ionEnergy; 
   G4double energyInFluorescence = 0.; //testing purposes only
@@ -505,5 +498,6 @@
   if (eKineticEnergy < 0) 
     {
-      //It means that there was some problem/mismatch between the two databases. Try to make it work
+      //It means that there was some problem/mismatch between the two databases. 
+      //Try to make it work
       //In this case available Energy (diffEnergy) < ionEnergy
       //Full residual energy is deposited locally
@@ -511,54 +505,61 @@
       eKineticEnergy = 0.0;
     }
-  G4double cutForLowEnergySecondaryPhotons = 250.0*eV;
-
-  //Get the cut for electrons
-  const G4ProductionCutsTable* theCoupleTable=
-    G4ProductionCutsTable::GetProductionCutsTable();
-  size_t indx = couple->GetIndex();
-  G4double cutE = (*(theCoupleTable->GetEnergyCutsVector(1)))[indx];
-  cutE = std::max(cutForLowEnergySecondaryPhotons,cutE);
      
   //the local energy deposit is what remains: part of this may be spent for fluorescence.
-  if (fUseAtomicDeexcitation)
-    { 
-      G4int nPhotons=0;
-
-      G4double cutg = (*(theCoupleTable->GetEnergyCutsVector(0)))[indx];
-      cutg = std::max(cutForLowEnergySecondaryPhotons,cutg);
-
-      G4DynamicParticle* aPhoton;
-      G4AtomicDeexcitation deexcitationManager;
+  if(DeexcitationFlag() && Z > 5) {
+
+    const G4ProductionCutsTable* theCoupleTable=
+      G4ProductionCutsTable::GetProductionCutsTable();
+
+    size_t index = couple->GetIndex();
+    G4double cutg = (*(theCoupleTable->GetEnergyCutsVector(0)))[index];
+    G4double cute = (*(theCoupleTable->GetEnergyCutsVector(1)))[index];
+
+    // Generation of fluorescence
+    // Data in EADL are available only for Z > 5
+    // Protection to avoid generating photons in the unphysical case of
+    // shell binding energy > photon energy
+    if (localEnergyDeposit > cutg || localEnergyDeposit > cute)
+      { 
+	G4DynamicParticle* aPhoton;
+	G4AtomicDeexcitation deexcitationManager;
+	deexcitationManager.SetCutForSecondaryPhotons(cutg);
+	deexcitationManager.SetCutForAugerElectrons(cute);
+	deexcitationManager.ActivateAugerElectronProduction(false);
       
-      if (Z>5 && (localEnergyDeposit > cutg || localEnergyDeposit > cutE))
-	{
-	  photonVector = deexcitationManager.GenerateParticles(Z,shellId);
-	  for (size_t k=0;k<photonVector->size();k++){
-	    aPhoton = (*photonVector)[k];
-	    if (aPhoton)
+	photonVector = deexcitationManager.GenerateParticles(Z,shellId);
+	if(photonVector) 
+	  {
+	    size_t nPhotons = photonVector->size();
+	    for (size_t k=0; k<nPhotons; k++)
 	      {
-		G4double itsCut = cutg;
-		if (aPhoton->GetDefinition() == G4Electron::Electron()) itsCut = cutE;
-		G4double itsEnergy = aPhoton->GetKineticEnergy();
-		if (itsEnergy > itsCut && itsEnergy <= localEnergyDeposit)
+		aPhoton = (*photonVector)[k];
+		if (aPhoton)
 		  {
-		    nPhotons++;
-		    localEnergyDeposit -= itsEnergy;
-		    energyInFluorescence += itsEnergy;
-		  }
-		else
-		  {
-		    delete aPhoton;
-		    (*photonVector)[k]=0;
+		    G4double itsEnergy = aPhoton->GetKineticEnergy();
+		    if (itsEnergy <= localEnergyDeposit)
+		      {
+			localEnergyDeposit -= itsEnergy;
+			if (aPhoton->GetDefinition() == G4Gamma::Gamma()) 
+			  energyInFluorescence += itsEnergy;;
+			fvect->push_back(aPhoton);		    
+		      }
+		    else
+		      {
+			delete aPhoton;
+			(*photonVector)[k]=0;
+		      }
 		  }
 	      }
-	  }
-	}
-    }
+	    delete photonVector;
+	  }
+      }
+  }
 
   //Produce explicitely the electron only if its proposed kinetic energy is 
   //above the cut, otherwise add local energy deposition
   G4DynamicParticle* electron = 0;
-  if (eKineticEnergy > cutE)
+  //  if (eKineticEnergy > cutE) // VI: may be consistency problem if cut is applied here
+  if (eKineticEnergy > 0.0)
     {
       G4double xEl = sinThetaE * std::cos(phi+pi); 
@@ -576,18 +577,4 @@
     }
 
-  //This block below is executed only if there is at least one secondary photon produced by
-  //AtomicDeexcitation
-  if (photonVector)
-    {
-      for (size_t ll=0;ll<photonVector->size();ll++)
-	{
-	  if ((*photonVector)[ll]) 
-	    {
-	      G4DynamicParticle* aFluorescencePhoton = (*photonVector)[ll];
-	      fvect->push_back(aFluorescencePhoton);
-	    }
-	}
-    }
-  delete photonVector;
   if (localEnergyDeposit < 0)
     {
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversion.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversion.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversion.cc	(revision 1055)
@@ -97,4 +97,14 @@
 	      << G4endl;
      }
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4PenelopeGammaConversion is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
  
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopeGammaConversionModel.cc,v 1.2 2008/12/04 14:09:36 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeGammaConversionModel.cc,v 1.4 2009/05/19 14:57:01 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Luciano Pandola
@@ -32,4 +32,10 @@
 // --------
 // 06 Oct 2008   L Pandola    Migration from process to model 
+// 17 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - do not apply production threshold on level of the model
+// 19 May 2009   L Pandola    Explicitely set to zero pointers deleted in 
+//                            Initialise(), since they might be checked later on
 //
 
@@ -56,5 +62,5 @@
   fSmallEnergy = 1.1*MeV;
 
-  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
+  //  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
   SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
   //
@@ -89,23 +95,10 @@
       crossSectionHandler->Clear();
       delete crossSectionHandler;
+      crossSectionHandler = 0;
     }
   
-  //Check energy limits
-  if (LowEnergyLimit() < fIntrinsicLowEnergyLimit)
-    {
-      G4cout << "G4PenelopeGammaConversionModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << fIntrinsicLowEnergyLimit/eV << " eV" << G4endl;
-      SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
-    }
-  if (HighEnergyLimit() > fIntrinsicHighEnergyLimit)
-    {
-      G4cout << "G4PenelopeGammaConversionModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << fIntrinsicHighEnergyLimit/GeV << " GeV" << G4endl;
-      SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
-    }
-
   //Re-initialize cross section handler
   crossSectionHandler = new G4CrossSectionHandler();
-  crossSectionHandler->Initialise(0,LowEnergyLimit(),HighEnergyLimit(),400);
+  crossSectionHandler->Initialise(0,fIntrinsicLowEnergyLimit,HighEnergyLimit(),400);
   crossSectionHandler->Clear();
   G4String crossSectionFile = "penelope/pp-cs-pen-";
@@ -117,16 +110,14 @@
     G4cout << "Loaded cross section files for PenelopeGammaConversion" << G4endl;
 
-  G4cout << "Penelope Gamma Conversion model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / MeV << " MeV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+  if (verboseLevel > 0) { 
+    G4cout << "Penelope Gamma Conversion model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / MeV << " MeV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -151,10 +142,10 @@
 
   G4int iZ = (G4int) Z;
-  if (!crossSectionHandler)
-    {
-      G4cout << "G4PenelopeGammaConversionModel::ComputeCrossSectionPerAtom" << G4endl;
-      G4cout << "The cross section handler is not correctly initialized" << G4endl;
-      G4Exception();
-    }
+  //  if (!crossSectionHandler) //VI: should not be checked in run time
+  //  {
+  //    G4cout << "G4PenelopeGammaConversionModel::ComputeCrossSectionPerAtom" << G4endl;
+  //    G4cout << "The cross section handler is not correctly initialized" << G4endl;
+  //    G4Exception();
+  //  }
   G4double cs = crossSectionHandler->FindValue(iZ,energy);
 
@@ -167,9 +158,10 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void G4PenelopeGammaConversionModel::SampleSecondaries(std::vector<G4DynamicParticle*>* fvect,
-					      const G4MaterialCutsCouple* couple,
-					      const G4DynamicParticle* aDynamicGamma,
-					      G4double,
-					      G4double)
+void 
+G4PenelopeGammaConversionModel::SampleSecondaries(std::vector<G4DynamicParticle*>* fvect,
+						  const G4MaterialCutsCouple* couple,
+						  const G4DynamicParticle* aDynamicGamma,
+						  G4double,
+						  G4double)
 {
   //
@@ -191,11 +183,13 @@
   G4double photonEnergy = aDynamicGamma->GetKineticEnergy();
 
-  if (photonEnergy <= LowEnergyLimit())
-  {
-      fParticleChange->ProposeTrackStatus(fStopAndKill);
-      fParticleChange->SetProposedKineticEnergy(0.);
+  // Always kill primary
+  fParticleChange->ProposeTrackStatus(fStopAndKill);
+  fParticleChange->SetProposedKineticEnergy(0.);
+
+  if (photonEnergy <= fIntrinsicLowEnergyLimit)
+    {
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy);
       return ;
-  }
+    }
 
   G4ParticleMomentum photonDirection = aDynamicGamma->GetMomentumDirection();
@@ -310,11 +304,7 @@
 
   //Generate explicitely the electron in the pair, only if it is > threshold
-  const G4ProductionCutsTable* theCoupleTable=
-    G4ProductionCutsTable::GetProductionCutsTable();
-  size_t indx = couple->GetIndex();
-  G4double cutE = (*(theCoupleTable->GetEnergyCutsVector(1)))[indx];
-  //G4double cutP = (*(theCoupleTable->GetEnergyCutsVector(2)))[indx];
-
-  if (electronKineEnergy > cutE)
+  //VI: applying cut here provides inconsistency 
+
+  if (electronKineEnergy > 0.0)
     {
       G4ThreeVector electronDirection ( dirX_el, dirY_el, dirZ_el);
@@ -333,5 +323,6 @@
   //Generate the positron. Real particle in any case, because it will annihilate. If below
   //threshold, produce it at rest
-  if (positronKineEnergy < cutE)
+  // VI: here there was a bug - positron and electron cuts are different
+  if (positronKineEnergy < 0.0)
     {
       localEnergyDeposit += positronKineEnergy;
@@ -344,11 +335,8 @@
   fvect->push_back(positron);
 
-  //Update the status of the primary gamma (kill it)
-  fParticleChange->SetProposedKineticEnergy(0.);
+  //Add rest of energy to the local energy deposit
   fParticleChange->ProposeLocalEnergyDeposit(localEnergyDeposit);
-  fParticleChange->ProposeTrackStatus(fStopAndKill);
-
   
- if (verboseLevel > 1)
+  if (verboseLevel > 1)
     {
       G4cout << "-----------------------------------------------------------" << G4endl;
@@ -357,5 +345,6 @@
       G4cout << "-----------------------------------------------------------" << G4endl;
       if (electronKineEnergy)
-	G4cout << "Electron (explicitely produced) " << electronKineEnergy/keV << " keV" << G4endl;
+	G4cout << "Electron (explicitely produced) " << electronKineEnergy/keV << " keV" 
+	       << G4endl;
       if (positronKineEnergy)
 	G4cout << "Positron (not at rest) " << positronKineEnergy/keV << " keV" << G4endl;
@@ -373,10 +362,9 @@
 				      localEnergyDeposit+2.0*electron_mass_c2-photonEnergy);
       if (energyDiff > 0.05*keV)
-	G4cout << "Warning from G4PenelopeGammaConversion: problem with energy conservation: " << 
-	  (electronKineEnergy+positronKineEnergy+
-	   localEnergyDeposit+2.0*electron_mass_c2)/keV << " keV (final) vs. " << 
-	  photonEnergy/keV << " keV (initial)" << G4endl;
-    }
-  
+	G4cout << "Warning from G4PenelopeGammaConversion: problem with energy conservation: " 
+	       << (electronKineEnergy+positronKineEnergy+
+		   localEnergyDeposit+2.0*electron_mass_c2)/keV 
+	       << " keV (final) vs. " << photonEnergy/keV << " keV (initial)" << G4endl;
+    } 
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopeIonisation.cc,v 1.19 2006/06/29 19:40:49 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeIonisation.cc,v 1.20 2009/05/02 09:59:16 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 // 
 // --------------------------------------------------------------
@@ -93,4 +93,14 @@
   ReadData(); //Read data from file
  
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4PenelopeIonisation is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
+
 }
 
